// 
// ALL RIGHTS RESERVED:
// ====================
// The contents of this file, and associated files in this directory, are 
// Copyright (C) Serial Port Tool(SPT) , all rights reserved, 2010.
// All software Source Code, Images, Database-Design and code, Graphics Design 
// and source files, and related content (collectively referred to as SOURCE) are 
// Copyright (C) SPT, 2009, All Rights Reserved.
// http://SerialPortTool.com
//
// Comm Operator is a Registered Trademark of SerialPortTool.com.

//About User Exe Sample
// This is sample exe can be called in AutoSend Rule. 

using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;

namespace UserExeSample
{
    class Program
    {
        /// <summary>
        ///  The user's exe will be called in every auto send loop in Comm Operator
        ///  Comm Operator will write data to stdio. User's exe read those data. Comm Operator will read the retun data from STDOUT and send those data
        /// Format
        /// Type, hex hex hex ...
        /// Type: String that represent the type of event, can be  
        ///       "DataReceived"
        ///       "Start" 
        ///       "Pause"         
        ///       "Resume" 
        /// If the type is "DataReceived", it will follow byte "," and then the data in hex string.
        /// For example, if the Comm Operator recieved string "abcd", it will call script with data like below
        ///   DataReceived, 61 62 63 64
        /// <param name="args"></param>
        static void Main(string[] args)
        {
            try
            {
                //  Read data send from Comm Operator
                string str = Console.ReadLine();
                // Parse data, the data contains two parts. The first part is event type, the seond part are data in hex string
                string[] strs = str.Split(',');

                //test if it is the "DataReceived" event
                if (strs[0] == "DataReceived")
                {
                    Console.WriteLine(strs[1]);
                }

                // test if it is the "Start" event
                if (strs[0] == "Start")
                {
                    Console.WriteLine(ascii_to_hex("Start"));
                }

                // test if it is the "Pause" event
                if (strs[0] == "Resume")
                {
                    Console.WriteLine(ascii_to_hex("Resume"));
                }

                //  test if it is the "Resume" event
                if (strs[0] == "Pause")
                {
                    Console.WriteLine(ascii_to_hex("Pause"));
                }

                //  test if it is the "Loop" event
                if (strs[0] == "Loop")
                {
                    
                    //System.Threading.Thread.Sleep(1000);
                    //Console.WriteLine(ascii_to_hex("Loop"));
                }

            }
            catch
            {

            }
        }

        // Help function, used to process data to Comm Operator
        // convert ascii string to hex string
        // for example "ABCD" --> "41 42 43 44 "
        static string ascii_to_hex(string str)
        {
            StringBuilder sb = new StringBuilder();
            Encoding coding = Encoding.GetEncoding("iso-8859-1");
            byte[] data = coding.GetBytes(str);
            foreach (byte b in data)
            {
                sb.AppendFormat("{0:X2} ", b);
            }
            return sb.ToString();
        }

        // Help function, used to process data from Comm Operator
        // convert hex string t ascii string
        // for example
        // "41 42 43 44 " --> "ABCD"
        static string hex_to_ascii(string str)
        {
            ArrayList list = new ArrayList();
            string[] strs = str.Split(new char[] { ' ' }, StringSplitOptions.RemoveEmptyEntries);
            foreach (string s in strs)
            {
                list.Add(Convert.ToByte(s, 16));
            }
            Encoding coding = Encoding.GetEncoding("iso-8859-1");
            byte[] data = (byte[])list.ToArray(typeof(byte));
            return coding.GetString(data, 0, data.Length);

        }
    }
}
